#include "StdAfx.h"
#include "WASSMS.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"

CWASSMS::CWASSMS(CWASActor *pActor) : CWASCommand(pActor)
{

}

CWASSMS::~CWASSMS(void)
{
}

void CWASSMS::ExecuteAsync()
{


	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	USES_UTF8_CONVERSION;

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/admin/SendSMS.php");

	m_httpFacade.StopRequest();
	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);
	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));	
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());

	m_httpFacade.session().AddBodyVariable("ostype", W2U8(_T("1")));
	m_httpFacade.session().AddBodyVariable("fromTelNo", W2U8(m_strFromTelNo.c_str()));
	m_httpFacade.session().AddBodyVariable("toTelNos", W2U8(m_strToTelNo.c_str()));
	m_httpFacade.session().AddBodyVariable("content", W2U8(m_strContent.c_str()));

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}



bool CWASSMS::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	nfc::IIkXMLNode *pNode = NULL;
	nfc::IIkXMLAttribute *pAttr = NULL;

	if(pDom == NULL)
		return false;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return false;
	}	


	return true;
}


// override in drived class
void CWASSMS::OnWasResponse(trid_t trid,
									bool bSuccess,
									int /*nWinINetErrorCode*/, 
									int /*nHttpResponseCode*/, 
									LPCSTR /*szWasResCodeInHeader*/, 
									LPCSTR szWasResCodeInXml,
									nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
		{
			m_eError = wasError_Protocol;
		}

	}

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
		if((*it)->OnGTWASActor_ResponseSMS(m_pActor, GetID(), m_eError, m_SMSData) == false)
			break;

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASSMS::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();	

	for (; it != observers.end(); ++it)
		if((*it)->OnGTWASActor_ResponseSMS(m_pActor, GetID(), m_eError, m_SMSData) == false)
			break;

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}